"use strict";
function overrideSpecIFrameToApplyToAppIFrame() {
    var specIframe = window.parent.document.querySelector('iframe.spec-iframe');
    if (!specIframe) {
        throw new Error('Cannot find .spec-iframe');
    }
    var specDocument = specIframe.contentDocument;
    if (!specDocument) {
        throw new Error('Cannot find contentDocument on specIframe');
    }
    var rootDocument = window.parent.document;
    var appIframe = rootDocument.querySelector('iframe.aut-iframe');
    if (!appIframe) {
        throw new Error('Cannot find .aut-iframe');
    }
    var appDocument = appIframe.contentDocument;
    if (!appDocument) {
        throw new Error('Cannot find contentDocument on appIframe');
    }
    {
        var originalEventListener_1 = specDocument.addEventListener;
        var addEventListener_1 = function () {
            originalEventListener_1.apply(this, arguments);
            appDocument.addEventListener.apply(appDocument, arguments);
        };
        if (specDocument.addEventListener !== addEventListener_1) {
            specDocument.addEventListener = addEventListener_1;
        }
    }
    {
        var documentAppendChild = function () {
            return appDocument.appendChild.apply(appDocument, arguments);
        };
        if (specDocument.appendChild !== documentAppendChild) {
            specDocument.appendChild = documentAppendChild;
        }
    }
    {
        var documentRemoveChild = function () {
            return appDocument.removeChild.apply(appDocument, arguments);
        };
        if (specDocument.removeChild !== documentRemoveChild) {
            specDocument.removeChild = documentRemoveChild;
        }
    }
    {
        var bodyAppendChild = function () {
            return appDocument.body.appendChild.apply(appDocument.body, arguments);
        };
        if (specDocument.body.appendChild !== bodyAppendChild) {
            specDocument.body.appendChild = bodyAppendChild;
        }
    }
    {
        var bodyRemoveChild = function () {
            return appDocument.body.removeChild.apply(appDocument, arguments);
        };
        if (specDocument.body.removeChild !== bodyRemoveChild) {
            specDocument.body.removeChild = bodyRemoveChild;
        }
    }
    {
        var documentQuerySelector = function () {
            return appDocument.querySelector.apply(appDocument, arguments);
        };
        if (specDocument.querySelector !== documentQuerySelector) {
            specDocument.querySelector = documentQuerySelector;
        }
    }
    {
        var bodyQuerySelector = function () {
            return appDocument.body.querySelector.apply(appDocument.body, arguments);
        };
        if (specDocument.body.querySelector !== bodyQuerySelector) {
            specDocument.body.querySelector = bodyQuerySelector;
        }
    }
    {
        var documentQueryAllSelector = function () {
            return appDocument.querySelectorAll.apply(appDocument, arguments);
        };
        if (specDocument.querySelectorAll !== documentQueryAllSelector) {
            specDocument.querySelectorAll = documentQueryAllSelector;
        }
    }
    {
        var bodyQueryAllSelector = function () {
            return appDocument.body.querySelectorAll.apply(appDocument.body, arguments);
        };
        if (specDocument.body.querySelectorAll !== bodyQueryAllSelector) {
            specDocument.body.querySelectorAll = bodyQueryAllSelector;
        }
    }
}
before(overrideSpecIFrameToApplyToAppIFrame);
